Bug 861789 - Linking with -flto doesn't work.
Linking with -flto doesn't work.
Status: CLOSED WONTFIX
Product: Fedora
Classification: Fedora
Component: cross-gcc (Show other bugs)
17
Unspecified Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: David Howells
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2012-09-30 14:43 EDT by Ralph Loader
Modified: 2013-07-31 19:52 EDT (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-07-31 19:52:11 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Ralph Loader 2012-09-30 14:43:35 EDT
Attempting to link with arm-linux-gnu-gcc with the -flto flag fails, apparently due to attempting to use the wrong linker:

$ arm-linux-gnu-gcc -march=armv7-m -mthumb -flto -o start.bin.elf start.o
collect2: fatal error: cannot find 'ld'

Removing -flto from the command line causes the link to proceed as expected.
Comment 1 Ralph Loader 2012-10-19 00:22:41 EDT
A fix is to add to the gcc configure command line: --with-plugin-ld=ld.

[That looks odd for a cross-compiler.  But if you look in the collect2.c source, it makes the linker lookup for LTO match the non-LTO lookup:

  static const char *const ld_suffix	= "ld";
  static const char *const plugin_ld_suffix = PLUGIN_LD;

It is possibly a gcc bug the PLUGIN_LD is defaulting to $TARGET_LD not "ld", since PLUGIN_LD is not something we're searching for in $PATH.
]


Setting with DEFAULT_LINKER or REAL_LD_FILE_NAME are probably other ways of fixing this.  [Or just rip out the convoluted lookup mess from collect2.c and hard-wire something sensible.]
Comment 2 Fedora End Of Life 2013-07-03 18:10:58 EDT
This message is a reminder that Fedora 17 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 17. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '17'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 17's end of life.

Bug Reporter:  Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 17 is end of life. If you 
would still like  to see this bug fixed and are able to reproduce it 
against a later version  of Fedora, you are encouraged  change the 
'version' to a later Fedora version prior to Fedora 17's end of life.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.
Comment 3 Fedora End Of Life 2013-07-31 19:52:14 EDT
Fedora 17 changed to end-of-life (EOL) status on 2013-07-30. Fedora 17 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.